<?php

// Copyright 2007-2009 Jonathan Brown


function _op_video_views_op_videos_fields($name) {

  $fields = array(
  
    'inline_player' => array(
      'group' => 'Content',
      'title' => 'Inline Video - (field_video)',
      'title_short' => 'Inline Video',
      'help' => 'OpenPackage Video - Appears in: Video',
      
      'field' => array(
        'field' => 'video_id',
        'table' => 'video_data_field_video',
        'handler' => '_op_video_views_handler_inline_player'
      )
    ),
      
    'duration' => array(
      'group' => 'Content',
      'title' => 'Duration - (field_video)',
      'title_short' => 'Duration',
      'help' => 'OpenPackage Video - Appears in: Video',
      
      'field' => array(
        'field' => 'duration',
        'table' => 'video_data_field_video',
 //       'handler' => '_op_video_views_handler_duration'
      )
    )

/*      
      'name' => $name . t(': Inline player'),
      'help' => t('Render the video player inline.'),
    ),

    'preview_image_link' => array(
      'field' => 'video_id',
      'name' => $name . t(': Preview image - link to node'),
      'help' => t("Display the video's preview image (linking to the node). Specify the dimensions in the option field."),
      'handler' => '_op_video_views_handler_preview_image_link',
      'option' => _op_video_dimensions_form()
    ),

    'preview_image_layer' => array(
      'field' => 'video_id',
      'name' => $name . t(': Preview image - play in layer'),
      'help' => t("Display the video's preview image (to be played in a layer when clicked). Specify the dimensions of the image in the option field."),
      'handler' => '_op_video_views_handler_preview_image_layer',
      'option' => _op_video_dimensions_form()
    ),

    'duration' => array(
      'name' => $name . t(': Duration'),
      'help' => t('Display the duration of the video. The option field may be used to specify how many units to display.'),
      'sortable' => TRUE,
      'handler' => '_op_video_views_handler_duration',
      'option' => 'integer',
    ),
*/
  );
  
  return $fields;
}


function _op_video_views_op_videos_sorts($name) {

  $sorts = array(
  
    'duration' => array(
      'name' => $name . t(': Duration'),
      'help' => t('Sort by the duration of the video.'),
    )
  );
  
  return $sorts;
}


function _op_video_views_op_videos_filters($name) {

  $filters = array(
  
    'video_id' => array(
      'name' => $name . t(': Video present'),
      'help' => t('Filter on the video being present.'),
      'operator' => array('' => t('Equals')),
      'list' => 'views_handler_operator_yesno',
      'list-type' => 'select',
      'handler' => '_op_video_views_is_null_filter_handler'
    ),

    'flv_file_id' => array(
      'name' => $name . t(': Video transcoded'),
      'help' => t('Filter on the video having been transcoded.'),
      'operator' => array('' => t('Equals')),
      'list' => 'views_handler_operator_yesno',
      'list-type' => 'select',
      'handler' => '_op_video_views_is_null_filter_handler'
    )
  );

  return $filters;
}


function _op_video_views_is_null_filter_handler($op, $filterdata, $filterinfo, &$query) {

  if($filterdata['value'])
    $query->add_where($filterdata['field'] . ' IS NOT NULL');
  else
    $query->add_where($filterdata['field'] . ' IS NULL');
}


function _op_video_views_handler_inline_player($fieldinfo, $fielddata, $value, $data) {
  $video = _op_video_load($value);
  
  return _op_video_render_video($video, 'default', $data->nid);
}


function _op_video_views_handler_preview_image_link($fieldinfo, $fielddata, $value, $data) {
  $video = _op_video_load($value);
  $dimensions = unserialize($fielddata['options']);
  
  return _op_video_render_preview_image_link($video, $data->nid, $dimensions['width'], $dimensions['height']);
}


function _op_video_views_handler_preview_image_layer($fieldinfo, $fielddata, $value, $data) {
  $video = _op_video_load($value);
  $dimensions = unserialize($fielddata['options']);

  return _op_video_render_preview_image_layer($video, $dimensions['width'], $dimensions['height']);
}


function _op_video_dimensions_form() {

  return array(
    'width' => array(
      '#type' => 'textfield',
      '#title' => t('Width'),
      '#size' => 3,
      '#maxlength' => 3
    ),
    'height' => array(
      '#type' => 'textfield',
      '#title' => t('Height'),
      '#size' => 3,
      '#maxlength' => 3
    ),
    '#type' => 'op_video_dimensions_output',
    '#process' => array('_op_video_dimensions_form_process' => array()),
    '#after_build' => array('_op_video_dimensions_form_after_build')
  );
}


function _op_video_dimensions_form_process($element) {
  $values = unserialize($element['#default_value']);
  if (!is_array($values)) {
    // set default values for options that have no stored value.
    $values = array('width' => 160, 'height' => 120);
  }
  $element['width']['#default_value'] = $values['width'];
  $element['height']['#default_value'] = $values['height'];
  return $element;
}


function _op_video_dimensions_form_after_build($element) {
  $values['width'] = $element['width']['#value'];
  $values['height'] = $element['height']['#value'];
  $element['#value'] = serialize($values);
  form_set_value($element, $element['#value'], $form_state);
  return $element;
}


function theme_op_video_dimensions_output($element) {
  return $element['#children'];
}


function _op_video_views_handler_bytesize($fieldinfo, $fielddata, $value, $data) {
  
  if($value)
    return storage_format_size($value);
  else
    return t('n/a');
}



function _op_video_views_handler_duration($fieldinfo, $fielddata, $value, $data) {
  
  if($value)
    return t('%time', array('%time' => format_interval($value, is_numeric($fielddata['options']) ? $fielddata['options'] : 2)));
  else
    return t('n/a');
}


